#class auto

#use "i2c_devices.lib"

//for Serial Setup
#define BINBUFSIZE 31
#define BOUTBUFSIZE 31
#define MSSG_TMOUT 2000UL

//I2C device address of  CS8416
#define CS8416_ADDRESS 0x20
//AD0 = 0
//AD1 = 0
//AD2 = 0
//BASE = 0010xxx

#define TAS5508_ADDRESS 0x36

int currentfs;
int currentFilterMenu;
int FilterChanged;

int currentEQMenu;
int EQChanged;

struct Params {
   int currentvol;
   int currentch;
   int currentwin;

   char CH12LPF;     //0:No LPF
   char CH12HPF;     //0:No HPF
   int CH12OFFSET;  //0:mid
   char CH12MUTE;    //0:normal, 1:mute
   char CH34LPF;     //0:No LPF
   char CH34HPF;     //0:No HPF
   int CH34OFFSET;  //0:mid
   char CH34MUTE;    //0:normal, 1:mute
   char CH56LPF;     //0:No LPF
   char CH56HPF;     //0:No HPF
   int CH56OFFSET;  //0:mid
   char CH56MUTE;    //0:normal, 1:mute
   char CH78LPF;     //0:No LPF
   char CH78HPF;     //0:No HPF
   int CH78OFFSET;  //0:mid
   char CH78MUTE;    //0:normal, 1:mute

   char CH12EQ5TYPE;	//0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
   char CH12EQ5FREQ;   //0 - 31
   char CH12EQ5Q;		//0 - 31
   int CH12EQ5GAIN;	//-15,... 0,... 15
   char CH12EQ6TYPE;	//0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
   char CH12EQ6FREQ;   //0 - 31
   char CH12EQ6Q;		//0 - 31
   int CH12EQ6GAIN;	//-15,... 0,... 15
   char CH12EQ7TYPE;	//0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
   char CH12EQ7FREQ;   //0 - 31
   char CH12EQ7Q;		//0 - 31
   int CH12EQ7GAIN;	//-15,... 0,... 15

   char CH34EQ5TYPE;	//0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
   char CH34EQ5FREQ;   //0 - 31
   char CH34EQ5Q;		//0 - 31
   int CH34EQ5GAIN;	//-15,... 0,... 15
   char CH34EQ6TYPE;	//0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
   char CH34EQ6FREQ;   //0 - 31
   char CH34EQ6Q;		//0 - 31
   int CH34EQ6GAIN;	//-15,... 0,... 15
   char CH34EQ7TYPE;	//0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
   char CH34EQ7FREQ;   //0 - 31
   char CH34EQ7Q;		//0 - 31
   int CH34EQ7GAIN;	//-15,... 0,... 15

   char CH56EQ5TYPE;	//0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
   char CH56EQ5FREQ;   //0 - 31
   char CH56EQ5Q;		//0 - 31
   int CH56EQ5GAIN;	//-15,... 0,... 15
   char CH56EQ6TYPE;	//0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
   char CH56EQ6FREQ;   //0 - 31
   char CH56EQ6Q;		//0 - 31
   int CH56EQ6GAIN;	//-15,... 0,... 15
   char CH56EQ7TYPE;	//0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
   char CH56EQ7FREQ;   //0 - 31
   char CH56EQ7Q;		//0 - 31
   int CH56EQ7GAIN;	//-15,... 0,... 15

   char CH78EQ5TYPE;	//0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
   char CH78EQ5FREQ;   //0 - 31
   char CH78EQ5Q;		//0 - 31
   int CH78EQ5GAIN;	//-15,... 0,... 15
   char CH78EQ6TYPE;	//0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
   char CH78EQ6FREQ;   //0 - 31
   char CH78EQ6Q;		//0 - 31
   int CH78EQ6GAIN;	//-15,... 0,... 15
   char CH78EQ7TYPE;	//0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
   char CH78EQ7FREQ;   //0 - 31
   char CH78EQ7Q;		//0 - 31
   int CH78EQ7GAIN;	//-15,... 0,... 15

} ;
struct Params DevParam;


//Utility Functions

void msDelay(unsigned int delay)
{
	auto unsigned long done_time;
	done_time = MS_TIMER + delay;
   while( (long) (MS_TIMER - done_time) < 0 );
}

void readDevParam()
{
	int retval;
   retval = readUserBlock(&DevParam, 0, sizeof(DevParam));
}

void writeDevParam()
{
	int retval;
   retval = writeUserBlock(0, &DevParam, sizeof(DevParam));
}

//LCD Functions
unsigned short get_crc(unsigned char * bufptr,unsigned short len)
{
	//CRC lookup table to avoid bit-shifting loops.
	unsigned short newCrc;
	static const unsigned short crcLookupTable[256] =
	{0x00000,0x01189,0x02312,0x0329B,0x04624,0x057AD,0x06536,0x074BF,
	0x08C48,0x09DC1,0x0AF5A,0x0BED3,0x0CA6C,0x0DBE5,0x0E97E,0x0F8F7,
	0x01081,0x00108,0x03393,0x0221A,0x056A5,0x0472C,0x075B7,0x0643E,
	0x09CC9,0x08D40,0x0BFDB,0x0AE52,0x0DAED,0x0CB64,0x0F9FF,0x0E876,
	0x02102,0x0308B,0x00210,0x01399,0x06726,0x076AF,0x04434,0x055BD,
	0x0AD4A,0x0BCC3,0x08E58,0x09FD1,0x0EB6E,0x0FAE7,0x0C87C,0x0D9F5,
	0x03183,0x0200A,0x01291,0x00318,0x077A7,0x0662E,0x054B5,0x0453C,
	0x0BDCB,0x0AC42,0x09ED9,0x08F50,0x0FBEF,0x0EA66,0x0D8FD,0x0C974,
	0x04204,0x0538D,0x06116,0x0709F,0x00420,0x015A9,0x02732,0x036BB,
	0x0CE4C,0x0DFC5,0x0ED5E,0x0FCD7,0x08868,0x099E1,0x0AB7A,0x0BAF3,
	0x05285,0x0430C,0x07197,0x0601E,0x014A1,0x00528,0x037B3,0x0263A,
	0x0DECD,0x0CF44,0x0FDDF,0x0EC56,0x098E9,0x08960,0x0BBFB,0x0AA72,
	0x06306,0x0728F,0x04014,0x0519D,0x02522,0x034AB,0x00630,0x017B9,
	0x0EF4E,0x0FEC7,0x0CC5C,0x0DDD5,0x0A96A,0x0B8E3,0x08A78,0x09BF1,
	0x07387,0x0620E,0x05095,0x0411C,0x035A3,0x0242A,0x016B1,0x00738,
	0x0FFCF,0x0EE46,0x0DCDD,0x0CD54,0x0B9EB,0x0A862,0x09AF9,0x08B70,
	0x08408,0x09581,0x0A71A,0x0B693,0x0C22C,0x0D3A5,0x0E13E,0x0F0B7,
	0x00840,0x019C9,0x02B52,0x03ADB,0x04E64,0x05FED,0x06D76,0x07CFF,
	0x09489,0x08500,0x0B79B,0x0A612,0x0D2AD,0x0C324,0x0F1BF,0x0E036,
	0x018C1,0x00948,0x03BD3,0x02A5A,0x05EE5,0x04F6C,0x07DF7,0x06C7E,
	0x0A50A,0x0B483,0x08618,0x09791,0x0E32E,0x0F2A7,0x0C03C,0x0D1B5,
	0x02942,0x038CB,0x00A50,0x01BD9,0x06F66,0x07EEF,0x04C74,0x05DFD,
	0x0B58B,0x0A402,0x09699,0x08710,0x0F3AF,0x0E226,0x0D0BD,0x0C134,
	0x039C3,0x0284A,0x01AD1,0x00B58,0x07FE7,0x06E6E,0x05CF5,0x04D7C,
	0x0C60C,0x0D785,0x0E51E,0x0F497,0x08028,0x091A1,0x0A33A,0x0B2B3,
	0x04A44,0x05BCD,0x06956,0x078DF,0x00C60,0x01DE9,0x02F72,0x03EFB,
	0x0D68D,0x0C704,0x0F59F,0x0E416,0x090A9,0x08120,0x0B3BB,0x0A232,
	0x05AC5,0x04B4C,0x079D7,0x0685E,0x01CE1,0x00D68,0x03FF3,0x02E7A,
	0x0E70E,0x0F687,0x0C41C,0x0D595,0x0A12A,0x0B0A3,0x08238,0x093B1,
	0x06B46,0x07ACF,0x04854,0x059DD,0x02D62,0x03CEB,0x00E70,0x01FF9,
	0x0F78F,0x0E606,0x0D49D,0x0C514,0x0B1AB,0x0A022,0x092B9,0x08330,
	0x07BC7,0x06A4E,0x058D5,0x0495C,0x03DE3,0x02C6A,0x01EF1,0x00F78};

	newCrc=0xFFFF;
	//This algorithm is based on the IrDA LAP example.

	while(len--)
   {
		newCrc = (newCrc >> 8) ^ crcLookupTable[(newCrc ^ *bufptr++) & 0xff];
   }
	//Make this crc match the onefs complement that is sent in the packet.
	return(~newCrc);
}

//String 0 terminated SendStr, Line is Upper(1) Lower(2)
void SendString(unsigned char * SendStr, int Line)
{
	unsigned char Packet[64];
   unsigned char Reply[64];
   unsigned short CRC;
   int StrLen;
   int i;

	if ((!(Line == 1)) && (!(Line == 2) ) )
   {
   	return;
   }
   if (Line == 1)
   {
   	Packet[0] = 7;
   }
   if (Line == 2)
   {
   	Packet[0] = 8;
   }

   StrLen = strlen(SendStr);
   if (StrLen > 16)
   {
   	return;
   }
   Packet[1] = 16;
   strncpy((Packet+2), SendStr, 16);

   for (i = StrLen + 1; i <= 16; i++)
   {
   	Packet[1+i] = 0x20;
   }
   CRC = get_crc(Packet, 18);
   Packet[19] = (CRC & 0xFF00) >> 8;
   Packet[18] = (CRC & 0xFF);
   serBwrite(Packet,20);
   msDelay(50);
   serBread(Reply, 4, MSSG_TMOUT);

}

void ClearLCD()
{
	unsigned char Packet[64];
   unsigned char Reply[64];
   unsigned short CRC;
   //Type(1Byte), Len(1Byte,0-18),data,CRC

   //Clear LCD
   Packet[0] = 6;
   Packet[1] = 0;
   CRC = get_crc(Packet, 2);
   Packet[3] = (CRC & 0xFF00) >> 8;
   Packet[2] = (CRC & 0xFF);
   serBwrite(Packet,4);
   msDelay(50);
   serBread(Reply, 4, MSSG_TMOUT);
}

int PollKey()
{
	unsigned char Packet[64];
   unsigned char Reply[64];
   unsigned short CRC;
   int NewKeyData;
   //Type(1Byte), Len(1Byte,0-18),data,CRC

   serBrdFlush();

   //Poll Key
   Packet[0] = 24;
   Packet[1] = 0;
   CRC = get_crc(Packet, 2);
   Packet[3] = (CRC & 0xFF00) >> 8;
   Packet[2] = (CRC & 0xFF);
   serBwrite(Packet,4);
   msDelay(50);
   serBread(Reply, 7, MSSG_TMOUT);
	if (Reply[0] == (0x40 | 24))
   {
   	NewKeyData = Reply[2] | Reply[3];
	   if (NewKeyData & 0x02)
	   {
	      return 1;	//ENTER
	   }
	   if (NewKeyData & 0x04)
	   {
      	return 2;	//cancel
	   }
	   if (NewKeyData & 0x01)
	   {
      	return 3;	//up
	   }
	   if (NewKeyData & 0x20)
	   {
      	return 4;	//Down
	   }
	   if (NewKeyData & 0x08)
	   {
      	return 5;	//Left
	   }
	   if (NewKeyData & 0x10)
	   {
      	return 6;	//right
	   }
	}
   return 0;
}

//I2C Functions
int I2C_GetFs()
{
	//returns data rate.
   //  0 : Error
   //  1 : invalid
   //  2 : 32 kHz
   //  3 : 38 kHz
   //  4 : 44.1kHz
   //  5 : 48 kHz
   //  6 : 88.2 kHz
   //  7 : 96 kHz
   //  8 : 176.4kHz
   //  9 : 192 kHz
   char Clk_Mode;
   int return_code;
   int retval;
   return_code = I2CRead(TAS5508_ADDRESS, 0x00, &Clk_Mode, 1);
   if (return_code != 0) {   	return 0;   }
   //if ( (Clk_Mode & 0x01) == 0){  return 1; }
   //upper 3 bit shows mode
   return ( ((Clk_Mode & 0xE0) >> 5) + 2  );
}

void I2C_SetVolume()
{
   char test_string[4];
   int return_code;

	//set volume
   test_string[0] = 0;
   test_string[1] = 0;
   test_string[2] = 0;
   test_string[3] = DevParam.currentvol & 0xff;
   return_code = I2CWrite(TAS5508_ADDRESS, 0xD9, test_string, 4);
}

void I2C_SetCH()
{
	unsigned char WriteData;
   switch (DevParam.currentch)
   {
   	case 0:
      	WriteData = 0x80;
         break;
   	case 1:
      	WriteData = 0x89;
         break;
   	case 2:
      	WriteData = 0x92;
         break;
   	case 3:
      	WriteData = 0x9B;
         break;
   	case 4:
      	WriteData = 0xA4;
         break;
   	case 5:
      	WriteData = 0xAD;
         break;
   	case 6:
      	WriteData = 0xB6;
         break;
   	case 7:
      	WriteData = 0xBF;
         break;
   	default:
      	WriteData = 0x80;
         break;
      }
   I2CWrite(CS8416_ADDRESS, 0x04, &WriteData, 1);
}

//Make biquad parameter
void MakeEQ(long Fs, int f0, int mode, float Q, int gain,  unsigned char * EQ)
{
	double w0;
   double cosw0;
   double sinw0;
   double alpha;
   double A;
   double b0;
   double b1;
   double b2;
   double a0;
   double a1;
   double a2;
   int i;
   long Qb0;
   long Qb1;
   long Qb2;
   long Qa1;
   long Qa2;

   w0 = 2.000 * 3.141516 * f0 / Fs;
   cosw0 = cos(w0);
   sinw0 = sin(w0);

   alpha = sinw0 / (2.00 * Q);
   A =  pow10( ((float)(gain)) /40.0 );

   if ( mode == 0) //HPF
   {
	   a0 = 1.0 + alpha;
	   b1 = -1.0 * (1.0 + cosw0) / a0 ;
	   b0 = -1.0 * b1 / 2.00;
	   b2 = b0;
	   a1 = -2.0 * cosw0 / a0 ;
	   a2 = (1.0 - alpha) / a0;
   }
   if ( mode == 1) //LPF
   {
	   a0 = 1.0 + alpha;
	   b1 = (1.0 - cosw0) / a0 ;
	   b0 = b1 / 2.00;
	   b2 = b0;
	   a1 = -2.0 * cosw0 / a0 ;
	   a2 = (1.0 - alpha) / a0;
   }

   if ( mode == 2) //LowShelf
   {
      a0 = (A+1)+(A-1)*cosw0+2*sqrt(A)*alpha;

	   b0 = A*((A+1) - (A-1)*cosw0 + 2*sqrt(A)*alpha);
	   b1 = 2*A*((A-1) - (A+1)*cosw0) ;
	   b2 = A*((A+1)-(A-1)*cosw0-2*sqrt(A)*alpha);
	   a1 = -2.0*((A-1)+(A+1)*cosw0) ;
	   a2 = (A+1)+(A-1)*cosw0-2*sqrt(A)*alpha;
   }
   if ( mode == 3) //HighShelf
   {
      a0 = (A+1)-(A-1)*cosw0+2*sqrt(A)*alpha;

	   b0 = A*((A+1) + (A-1)*cosw0 + 2*sqrt(A)*alpha);
	   b1 = -2*A*((A-1) + (A+1)*cosw0) ;
	   b2 = A*((A+1)+(A-1)*cosw0-2*sqrt(A)*alpha);
	   a1 = 2.0*((A-1)-(A+1)*cosw0) ;
	   a2 = (A+1)-(A-1)*cosw0-2*sqrt(A)*alpha;
   }
   if ( mode == 4) //Peaking
   {
	   a0 = 1.0 + alpha / A;

	   b0 = 1.0 + alpha * A;
	   b1 = -2.0 * cosw0 ;
	   b2 = 1.0 - alpha * A;
	   a1 = -2.0 * cosw0 ;
	   a2 = 1.0 - alpha / A;
   }
   if ( mode > 1)
   {
	   b0 = b0 / a0;
	   b1 = b1 / a0;
	   b2 = b2 / a0;
	   a1 = a1 / a0;
	   a2 = a2 / a0;
   }
   //quantize
   Qb0 = (long)(b0 *  8388608L);
   Qb1 = (long)(b1 *  8388608L);
   Qb2 = (long)(b2 *  8388608L);
   Qa1 = (long)(a1 * -8388608L);
   Qa2 = (long)(a2 * -8388608L);

   //Modify sign bit
   if (Qb0 < 0) Qb0 = Qb0 + 268435456L;
   if (Qb1 < 0) Qb1 = Qb1 + 268435456L;
   if (Qb2 < 0) Qb2 = Qb2 + 268435456L;
   if (Qa1 < 0) Qa1 = Qa1 + 268435456L;
   if (Qa2 < 0) Qa2 = Qa2 + 268435456L;

   //get each byte
   *(EQ   ) = (unsigned char)((Qb0>>24) & 0xFF);
   *(EQ+1 ) = (unsigned char)((Qb0>>16) & 0xFF);
   *(EQ+2 ) = (unsigned char)((Qb0>>8)  & 0xFF);
   *(EQ+3 ) = (unsigned char)( Qb0      & 0xFF);
   *(EQ+4 ) = (unsigned char)((Qb1>>24) & 0xFF);
   *(EQ+5 ) = (unsigned char)((Qb1>>16) & 0xFF);
   *(EQ+6 ) = (unsigned char)((Qb1>>8)  & 0xFF);
   *(EQ+7 ) = (unsigned char)( Qb1      & 0xFF);
   *(EQ+8 ) = (unsigned char)((Qb2>>24) & 0xFF);
   *(EQ+9 ) = (unsigned char)((Qb2>>16) & 0xFF);
   *(EQ+10) = (unsigned char)((Qb2>>8)  & 0xFF);
   *(EQ+11) = (unsigned char)( Qb2      & 0xFF);
   *(EQ+12) = (unsigned char)((Qa1>>24) & 0xFF);
   *(EQ+13) = (unsigned char)((Qa1>>16) & 0xFF);
   *(EQ+14) = (unsigned char)((Qa1>>8)  & 0xFF);
   *(EQ+15) = (unsigned char)( Qa1      & 0xFF);
   *(EQ+16) = (unsigned char)((Qa2>>24) & 0xFF);
   *(EQ+17) = (unsigned char)((Qa2>>16) & 0xFF);
   *(EQ+18) = (unsigned char)((Qa2>>8)  & 0xFF);
   *(EQ+19) = (unsigned char)( Qa2      & 0xFF);
}

void ClearEQ(unsigned char * EQ)
{
   //get each byte
   *(EQ   ) = 0x00;
   *(EQ+1 ) = 0x80;
   *(EQ+2 ) = 0x00;
   *(EQ+3 ) = 0x00;
   *(EQ+4 ) = 0x00;
   *(EQ+5 ) = 0x00;
   *(EQ+6 ) = 0x00;
   *(EQ+7 ) = 0x00;
   *(EQ+8 ) = 0x00;
   *(EQ+9 ) = 0x00;
   *(EQ+10) = 0x00;
   *(EQ+11) = 0x00;
   *(EQ+12) = 0x00;
   *(EQ+13) = 0x00;
   *(EQ+14) = 0x00;
   *(EQ+15) = 0x00;
   *(EQ+16) = 0x00;
   *(EQ+17) = 0x00;
   *(EQ+18) = 0x00;
   *(EQ+19) = 0x00;
}
float EQQNumToValue(int EQQ)
{
	float retVal;
   retVal = (EQQ * EQQ) / 100.00 ;
	return retVal;
}
int FreqFromEQSetting(int EQSetting)
{
	switch(EQSetting)
   {
   	case 0:
      	return 0;
         break;
      case 1:
      	return 20;
         break;
      case 2:
      	return 25;
         break;
      case 3:
      	return 32;
         break;
      case 4:
      	return 40;
         break;
      case 5:
      	return 50;
         break;
      case 6:
      	return 63;
         break;
      case 7:
      	return 80;
         break;
      case 8:
      	return 100;
         break;
      case 9:
      	return 125;
         break;
   	case 10:
      	return 160;
         break;
      case 11:
      	return 200;
         break;
      case 12:
      	return 250;
         break;
      case 13:
      	return 315;
         break;
      case 14:
      	return 400;
         break;
      case 15:
      	return 500;
         break;
      case 16:
      	return 630;
         break;
      case 17:
      	return 800;
         break;
      case 18:
      	return 1000;
         break;
      case 19:
      	return 1250;
         break;
   	case 20:
      	return 1600;
         break;
      case 21:
      	return 2000;
         break;
      case 22:
      	return 2500;
         break;
      case 23:
      	return 3150;
         break;
      case 24:
      	return 4000;
         break;
      case 25:
      	return 5000;
         break;
      case 26:
      	return 6300;
         break;
      case 27:
      	return 8000;
         break;
      case 28:
      	return 10000;
         break;
      case 29:
      	return 12500;
         break;
   	case 30:
      	return 16000;
         break;
      case 31:
      	return 20000;
         break;
      default:
      	return 0;
         break;
      }
}

int FreqFromFilterSetting(int FilterSetting)
{
	switch(FilterSetting)
   {
   	case 0:
      	return 0;
         break;
      case 1:
      	return 50;
         break;
      case 2:
      	return 65;
         break;
      case 3:
      	return 80;
         break;
      case 4:
      	return 100;
         break;
      case 5:
      	return 120;
         break;
      case 6:
      	return 150;
         break;
      case 7:
      	return 180;
         break;
      case 8:
      	return 220;
         break;
      case 9:
      	return 260;
         break;
   	case 10:
      	return 300;
         break;
      case 11:
      	return 350;
         break;
      case 12:
      	return 400;
         break;
      case 13:
      	return 500;
         break;
      case 14:
      	return 650;
         break;
      case 15:
      	return 800;
         break;
      case 16:
      	return 1000;
         break;
      case 17:
      	return 1200;
         break;
      case 18:
      	return 1500;
         break;
      case 19:
      	return 1800;
         break;
   	case 20:
      	return 2200;
         break;
      case 21:
      	return 2600;
         break;
      case 22:
      	return 3000;
         break;
      case 23:
      	return 3500;
         break;
      case 24:
      	return 4000;
         break;
      case 25:
      	return 5000;
         break;
      case 26:
      	return 6500;
         break;
      case 27:
      	return 8000;
         break;
      case 28:
      	return 10000;
         break;
      case 29:
      	return 12000;
         break;
   	case 30:
      	return 15000;
         break;
      case 31:
      	return 18000;
         break;
      default:
      	return 0;
         break;
      }
}

void applyEQ(long FS)
{
	unsigned char EQ[20];
   int return_code;
   int Freq;
   float Q;
   unsigned char Param[4];
   unsigned char MutePattern;

   //CH1-2 EQ5
   Freq = FreqFromEQSetting(DevParam.CH12EQ5FREQ);
   if ((Freq > 0) && (DevParam.CH12EQ5TYPE > 0))
   {
      Q = EQQNumToValue(DevParam.CH12EQ5Q);
	   MakeEQ(FS, Freq, DevParam.CH12EQ5TYPE+2, Q , DevParam.CH12EQ5GAIN, EQ);
   }
   else
   {
   	ClearEQ(EQ);
   }
   //CH1-2 EQ5
   return_code = I2CWrite(TAS5508_ADDRESS, 0x55,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x5C,EQ,20);

   //CH1-2 EQ6
   Freq = FreqFromEQSetting(DevParam.CH12EQ6FREQ);
   if ((Freq > 0) && (DevParam.CH12EQ6TYPE > 0))
   {
      Q = EQQNumToValue(DevParam.CH12EQ6Q);
	   MakeEQ(FS, Freq, DevParam.CH12EQ6TYPE+2, Q , DevParam.CH12EQ6GAIN, EQ);
   }
   else
   {
   	ClearEQ(EQ);
   }
   //CH1-2 EQ6
   return_code = I2CWrite(TAS5508_ADDRESS, 0x56,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x5D,EQ,20);

   //CH1-2 EQ7
   Freq = FreqFromEQSetting(DevParam.CH12EQ7FREQ);
   if ((Freq > 0) && (DevParam.CH12EQ7TYPE > 0))
   {
      Q = EQQNumToValue(DevParam.CH12EQ7Q);
	   MakeEQ(FS, Freq, DevParam.CH12EQ7TYPE+2, Q , DevParam.CH12EQ7GAIN, EQ);
   }
   else
   {
   	ClearEQ(EQ);
   }
   //CH1-2 EQ7
   return_code = I2CWrite(TAS5508_ADDRESS, 0x57,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x5E,EQ,20);

   //CH3-4 EQ5
   Freq = FreqFromEQSetting(DevParam.CH34EQ5FREQ);
   if ((Freq > 0) && (DevParam.CH34EQ5TYPE > 0))
   {
      Q = EQQNumToValue(DevParam.CH34EQ5Q);
	   MakeEQ(FS, Freq, DevParam.CH34EQ5TYPE+2, Q , DevParam.CH34EQ5GAIN, EQ);
   }
   else
   {
   	ClearEQ(EQ);
   }
   //CH3-4 EQ5
   return_code = I2CWrite(TAS5508_ADDRESS, 0x63,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x6A,EQ,20);

   //CH3-4 EQ6
   Freq = FreqFromEQSetting(DevParam.CH34EQ6FREQ);
   if ((Freq > 0) && (DevParam.CH34EQ6TYPE > 0) )
   {
      Q = EQQNumToValue(DevParam.CH34EQ6Q);
	   MakeEQ(FS, Freq, DevParam.CH34EQ6TYPE+2, Q , DevParam.CH34EQ6GAIN, EQ);
   }
   else
   {
   	ClearEQ(EQ);
   }
   //CH3-4 EQ6
   return_code = I2CWrite(TAS5508_ADDRESS, 0x64,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x6B,EQ,20);

   //CH3-4 EQ7
   Freq = FreqFromEQSetting(DevParam.CH34EQ7FREQ);
   if ((Freq > 0) && (DevParam.CH34EQ7TYPE > 0))
   {
      Q = EQQNumToValue(DevParam.CH34EQ7Q);
	   MakeEQ(FS, Freq, DevParam.CH34EQ7TYPE+2, Q , DevParam.CH34EQ7GAIN, EQ);
   }
   else
   {
   	ClearEQ(EQ);
   }
   //CH3-4 EQ7
   return_code = I2CWrite(TAS5508_ADDRESS, 0x65,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x6C,EQ,20);

   //CH5-6 EQ5
   Freq = FreqFromEQSetting(DevParam.CH56EQ5FREQ);
   if ((Freq > 0) && (DevParam.CH56EQ5TYPE > 0))
   {
      Q = EQQNumToValue(DevParam.CH56EQ5Q);
	   MakeEQ(FS, Freq, DevParam.CH56EQ5TYPE+2, Q , DevParam.CH56EQ5GAIN, EQ);
   }
   else
   {
   	ClearEQ(EQ);
   }
   //CH5-6 EQ5
   return_code = I2CWrite(TAS5508_ADDRESS, 0x71,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x78,EQ,20);

   //CH5-6 EQ6
   Freq = FreqFromEQSetting(DevParam.CH56EQ6FREQ);
   if ((Freq > 0) && (DevParam.CH56EQ6TYPE > 0))
   {
      Q = EQQNumToValue(DevParam.CH56EQ6Q);
	   MakeEQ(FS, Freq, DevParam.CH56EQ6TYPE+2, Q , DevParam.CH56EQ6GAIN, EQ);
   }
   else
   {
   	ClearEQ(EQ);
   }
   //CH5-6 EQ6
   return_code = I2CWrite(TAS5508_ADDRESS, 0x72,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x79,EQ,20);

   //CH5-6 EQ7
   Freq = FreqFromEQSetting(DevParam.CH56EQ7FREQ);
   if ((Freq > 0) && (DevParam.CH56EQ7TYPE > 0))
   {
      Q = EQQNumToValue(DevParam.CH56EQ7Q);
	   MakeEQ(FS, Freq, DevParam.CH56EQ7TYPE+2, Q , DevParam.CH56EQ7GAIN, EQ);
   }
   else
   {
   	ClearEQ(EQ);
   }
   //CH5-6 EQ7
   return_code = I2CWrite(TAS5508_ADDRESS, 0x73,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x7A,EQ,20);

   //CH7-8 EQ5
   Freq = FreqFromEQSetting(DevParam.CH78EQ5FREQ);
   if ((Freq > 0) && (DevParam.CH78EQ5TYPE > 0))
   {
      Q = EQQNumToValue(DevParam.CH78EQ5Q);
	   MakeEQ(FS, Freq, DevParam.CH78EQ5TYPE+2, Q , DevParam.CH78EQ5GAIN, EQ);
   }
   else
   {
   	ClearEQ(EQ);
   }
   //CH7-8 EQ5
   return_code = I2CWrite(TAS5508_ADDRESS, 0x7F,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x86,EQ,20);

   //CH7-8 EQ6
   Freq = FreqFromEQSetting(DevParam.CH78EQ6FREQ);
   if ((Freq > 0) && (DevParam.CH78EQ6TYPE > 0))
   {
      Q = EQQNumToValue(DevParam.CH78EQ6Q);
	   MakeEQ(FS, Freq, DevParam.CH78EQ6TYPE+2, Q , DevParam.CH78EQ6GAIN, EQ);
   }
   else
   {
   	ClearEQ(EQ);
   }
   //CH7-8 EQ6
   return_code = I2CWrite(TAS5508_ADDRESS, 0x80,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x87,EQ,20);

   //CH7-8 EQ7
   Freq = FreqFromEQSetting(DevParam.CH78EQ7FREQ);
   if ((Freq > 0) && (DevParam.CH78EQ7TYPE > 0))
   {
      Q = EQQNumToValue(DevParam.CH78EQ7Q);
	   MakeEQ(FS, Freq, DevParam.CH78EQ7TYPE+2, Q , DevParam.CH78EQ7GAIN, EQ);
   }
   else
   {
   	ClearEQ(EQ);
   }
   //CH7-8 EQ7
   return_code = I2CWrite(TAS5508_ADDRESS, 0x81,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x88,EQ,20);


}
void applyfilter(long FS)
{
	unsigned char EQ[20];
   int return_code;
   int Freq;
   unsigned char Param[4];
   unsigned char MutePattern;

   //CH1-2 EQ1,2 (LPF)
   Freq = FreqFromFilterSetting(DevParam.CH12LPF);
   if (Freq > 0)
   {
	   MakeEQ(FS, Freq, 1, 0.71, 0, EQ);     //Q=0.71 LPF
   }
   else
   {
   	ClearEQ(EQ);
   }
   //CH1-2 EQ1, EQ2
   return_code = I2CWrite(TAS5508_ADDRESS, 0x51,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x52,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x58,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x59,EQ,20);

   //CH1-2 EQ3,4 (HPF)
   Freq = FreqFromFilterSetting(DevParam.CH12HPF);
   if (Freq > 0)
   {
   	MakeEQ(FS, Freq, 0,  0.71, 0, EQ);     //Q=0.71, HPF
	}
   else
   {
   	ClearEQ(EQ);
   }
   return_code = I2CWrite(TAS5508_ADDRESS, 0x53,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x54,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x5A,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x5B,EQ,20);

   //CH3-4 EQ1,2 (LPF)
   Freq = FreqFromFilterSetting(DevParam.CH34LPF);
   if (Freq > 0)
   {
	   MakeEQ(FS, Freq, 1,0.71,  0, EQ);     //Q=0.71 LPF
	}
   else
   {
   	ClearEQ(EQ);
   }
   return_code = I2CWrite(TAS5508_ADDRESS, 0x5F,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x60,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x66,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x67,EQ,20);


   //CH3-4 EQ3,4 (HPF)
   Freq = FreqFromFilterSetting(DevParam.CH34HPF);
   if (Freq > 0)
   {
   	MakeEQ(FS, Freq,  0,0.71, 0, EQ);     //Q=0.71, HPF
	}
   else
   {
   	ClearEQ(EQ);
   }
   return_code = I2CWrite(TAS5508_ADDRESS, 0x61,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x62,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x68,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x69,EQ,20);

   //CH5-6 EQ1,2 (LPF)
   Freq = FreqFromFilterSetting(DevParam.CH56LPF);
   if (Freq > 0)
   {
	   MakeEQ(FS, Freq, 1,0.71,  0, EQ);     //Q=0.71 LPF
	}
   else
   {
   	ClearEQ(EQ);
   }
   return_code = I2CWrite(TAS5508_ADDRESS, 0x6D,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x6E,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x74,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x75,EQ,20);

   //CH5-6 EQ3,4 (HPF)
   Freq = FreqFromFilterSetting(DevParam.CH56HPF);
   if (Freq > 0)
   {
   	MakeEQ(FS, Freq,  0,0.71, 0, EQ);     //Q=0.71, HPF
	}
   else
   {
   	ClearEQ(EQ);
   }
   return_code = I2CWrite(TAS5508_ADDRESS, 0x6F,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x70,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x76,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x77,EQ,20);

   //CH7-8 EQ1,2 (LPF)
   Freq = FreqFromFilterSetting(DevParam.CH78LPF);
   if (Freq > 0)
   {
	   MakeEQ(FS, Freq,  1,0.71, 0, EQ);     //Q=0.71 LPF
	}
   else
   {
   	ClearEQ(EQ);
   }
   return_code = I2CWrite(TAS5508_ADDRESS, 0x7B,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x7C,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x82,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x83,EQ,20);

   //CH7-8 EQ3,4 (HPF)
   Freq = FreqFromFilterSetting(DevParam.CH78HPF);
   if (Freq > 0)
   {
   	MakeEQ(FS, Freq,  0,0.71, 0, EQ);     //Q=0.71, HPF
	}
   else
   {
   	ClearEQ(EQ);
   }
   return_code = I2CWrite(TAS5508_ADDRESS, 0x7D,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x7E,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x84,EQ,20);
   return_code = I2CWrite(TAS5508_ADDRESS, 0x85,EQ,20);

   Param[0] = 0;
   Param[1] = 0;
   Param[2] = 0;
   //CH1-2 Offset
   Param[3] = (unsigned char)(0x48 - DevParam.CH12OFFSET * 4);
	return_code = I2CWrite(TAS5508_ADDRESS, 0xD1,Param,4);
	return_code = I2CWrite(TAS5508_ADDRESS, 0xD2,Param,4);
   //CH3-4Offset
   Param[3] = (unsigned char)(0x48 - DevParam.CH34OFFSET * 4);
	return_code = I2CWrite(TAS5508_ADDRESS, 0xD3,Param,4);
	return_code = I2CWrite(TAS5508_ADDRESS, 0xD4,Param,4);
   //CH5-6 Offset
   Param[3] = (unsigned char)(0x48 - DevParam.CH56OFFSET * 4);
	return_code = I2CWrite(TAS5508_ADDRESS, 0xD5,Param,4);
	return_code = I2CWrite(TAS5508_ADDRESS, 0xD6,Param,4);
   //CH7-8 Offset
   Param[3] = (unsigned char)(0x48 - DevParam.CH78OFFSET * 4);
	return_code = I2CWrite(TAS5508_ADDRESS, 0xD7,Param,4);
	return_code = I2CWrite(TAS5508_ADDRESS, 0xD8,Param,4);

   //CH Mute
   MutePattern = (unsigned char)
   				 (DevParam.CH12MUTE * 0x03 +
   				  DevParam.CH34MUTE * 0x0C +
                 DevParam.CH56MUTE * 0x30 +
                 DevParam.CH78MUTE * 0xC0);
	return_code = I2CWrite(TAS5508_ADDRESS, 0x0F, &MutePattern,1);
}


void Menu01(int NewKeyData)
{
	char Line1[20];
   char Line2[20];

      switch (NewKeyData)
      {
      case 1:  //Enter
      	currentFilterMenu = 0;
         FilterChanged = 0;
         DevParam.currentwin = 3;
        	writeDevParam();
         return;
         break;
      case 2:
         DevParam.currentwin = 0;
        	writeDevParam();
         return;
         break;
      case 3:    //Up
         DevParam.currentwin = 0;
        	writeDevParam();
         return;
         break;
      case 4:    //Down
         break;
      case 5:    //Left
         DevParam.currentwin = 2;
        	writeDevParam();
         return;
         break;
      case 6:   //Right
         DevParam.currentwin = 2;
        	writeDevParam();
         return;
         break;
      default:
         //SendString("No Key",2);
         break;
      }

      //Create Screen String
      sprintf(Line1, "KDA-TAS4i");
      sprintf(Line2, "Filter Menu ?");
      //Send LCD
      SendString(Line1,1);
      SendString(Line2,2);
}

void Menu02(int NewKeyData)
{
	char Line1[20];
   char Line2[20];

      switch (NewKeyData)
      {
      case 1:  //Enter
         DevParam.currentwin = 4;
        	writeDevParam();
         return;
         break;
      case 2:  //cancel
         DevParam.currentwin = 0;
        	writeDevParam();
         return;
         break;
      case 3:    //Up
         DevParam.currentwin = 0;
        	writeDevParam();
         return;
         break;
      case 4:    //Down
         break;
      case 5:    //Left
         DevParam.currentwin = 1;
        	writeDevParam();
         return;
         break;
      case 6:   //Right
         DevParam.currentwin = 1;
        	writeDevParam();
         return;
         break;
      default:
         //SendString("No Key",2);
         break;
      }

      //Create Screen String
      sprintf(Line1, "KDA-TAS4i");
      sprintf(Line2, "EQ Menu ?");
      //Send LCD
      SendString(Line1,1);
      SendString(Line2,2);
}
void FilterNumToStr(int FilterNum, char * FilterStr)
{
	switch(FilterNum)
   {
   	case 0:
      	strcpy(FilterStr, "None");
      	break;
   	case 1:
      	strcpy(FilterStr, "50Hz");
      	break;
   	case 2:
      	strcpy(FilterStr, "65Hz");
      	break;
   	case 3:
      	strcpy(FilterStr, "80Hz");
      	break;
   	case 4:
      	strcpy(FilterStr, "100Hz");
      	break;
   	case 5:
      	strcpy(FilterStr, "120Hz");
      	break;
   	case 6:
      	strcpy(FilterStr, "150Hz");
      	break;
   	case 7:
      	strcpy(FilterStr, "180Hz");
      	break;
   	case 8:
      	strcpy(FilterStr, "220Hz");
      	break;
   	case 9:
      	strcpy(FilterStr, "260Hz");
      	break;
   	case 10:
      	strcpy(FilterStr, "300Hz");
      	break;
   	case 11:
      	strcpy(FilterStr, "350Hz");
      	break;
   	case 12:
      	strcpy(FilterStr, "400Hz");
      	break;
   	case 13:
      	strcpy(FilterStr, "500Hz");
      	break;
   	case 14:
      	strcpy(FilterStr, "650Hz");
      	break;
   	case 15:
      	strcpy(FilterStr, "800Hz");
      	break;
   	case 16:
      	strcpy(FilterStr, "1.0kHz");
      	break;
   	case 17:
      	strcpy(FilterStr, "1.2kHz");
      	break;
   	case 18:
      	strcpy(FilterStr, "1.5kHz");
      	break;
   	case 19:
      	strcpy(FilterStr, "1.8kHz");
      	break;
   	case 20:
      	strcpy(FilterStr, "2.2kHz");
      	break;
   	case 21:
      	strcpy(FilterStr, "2.6kHz");
      	break;
   	case 22:
      	strcpy(FilterStr, "3.0kHz");
      	break;
   	case 23:
      	strcpy(FilterStr, "3.5kHz");
      	break;
   	case 24:
      	strcpy(FilterStr, "4.0kHz");
      	break;
   	case 25:
      	strcpy(FilterStr, "5.0kHz");
      	break;
   	case 26:
      	strcpy(FilterStr, "6.5kHz");
      	break;
   	case 27:
      	strcpy(FilterStr, "8.0kHz");
      	break;
   	case 28:
      	strcpy(FilterStr, "10kHz");
      	break;
   	case 29:
      	strcpy(FilterStr, "12kHz");
      	break;
   	case 30:
      	strcpy(FilterStr, "15kHz");
      	break;
   	case 31:
      	strcpy(FilterStr, "18kHz");
      	break;
      default:
      	strcpy(FilterStr, "--");
			break;
      }
}
void MuteToStr(int MuteValue, char * MuteStr)
{
	if (MuteValue == 0)
   {
   	strcpy(MuteStr, "In Use");
   }
   else
   {
   	strcpy(MuteStr, "Mute");
   }
}

void FilterMenu(int NewKeyData)
{
	//Control EQ0,1(reserved for LPF) ,2,3 (for HPF)
	char Line1[20];
   char Line2[20];

      switch (NewKeyData)
      {
      case 1:  //Enter
      	//save changes
         FilterChanged = 0;
         DevParam.currentwin = 3;
         switch (currentfs)
         {
	         case 4:
                applyfilter(44100L);
                break;
	         case 5:
                applyfilter(48000L);
                break;
	         case 6:
                applyfilter(88200L);
                break;
	         case 7:
                applyfilter(96000L);
                break;
         }
        	writeDevParam();
         return;
         break;
      case 2:   //Cancel
      	//discard changes
         FilterChanged = 0;
        	readDevParam();
         DevParam.currentwin = 1;
        	writeDevParam();
         return;
         break;
      case 3:    //Up
      	if (currentFilterMenu > 0)
         	currentFilterMenu -= 1;

         break;
      case 4:    //Down
      	if (currentFilterMenu < 15)
         	currentFilterMenu += 1;
         break;
      case 5:    //Left
         FilterChanged = 1;
      	switch (currentFilterMenu)
         {
         	case 0:	// CH12LPF
            	if (DevParam.CH12LPF > 0)
               	 DevParam.CH12LPF -= 1;
               break;
            case 1:  // CH12HPF
            	if (DevParam.CH12HPF > 0)
               	 DevParam.CH12HPF -= 1;
               break;
            case 2:  // CH12OFFSET
               if (DevParam.CH12OFFSET > -15)
                   DevParam.CH12OFFSET -= 1;
               break;
            case 3:   // CH12MUTE
            	if (DevParam.CH12MUTE == 1)
               	 DevParam.CH12MUTE = 0;
               break;
         	case 4:	// CH34LPF
            	if (DevParam.CH34LPF > 0)
               	 DevParam.CH34LPF -= 1;
               break;
            case 5:  // CH34HPF
            	if (DevParam.CH34HPF > 0)
               	 DevParam.CH34HPF -= 1;
               break;
            case 6:  // CH34OFFSET
               if (DevParam.CH34OFFSET > -15)
                   DevParam.CH34OFFSET -= 1;
               break;
            case 7:   // CH34MUTE
            	if (DevParam.CH34MUTE == 1)
               	 DevParam.CH34MUTE = 0;
               break;
         	case 8:	// CH56LPF
            	if (DevParam.CH56LPF > 0)
               	 DevParam.CH56LPF -= 1;
               break;
            case 9:  // CH56HPF
            	if (DevParam.CH56HPF > 0)
               	 DevParam.CH56HPF -= 1;
               break;
            case 10:  // CH56OFFSET
               if (DevParam.CH56OFFSET > -15)
                   DevParam.CH56OFFSET -= 1;
               break;
            case 11:   // CH56MUTE
            	if (DevParam.CH56MUTE == 1)
               	 DevParam.CH56MUTE = 0;
               break;
         	case 12: // CH78LPF
            	if (DevParam.CH78LPF > 0)
               	 DevParam.CH78LPF -= 1;
               break;
            case 13:  // CH78HPF
            	if (DevParam.CH78HPF > 0)
               	 DevParam.CH78HPF -= 1;
               break;
            case 14:  // CH78OFFSET
               if (DevParam.CH78OFFSET > -15)
                   DevParam.CH78OFFSET -= 1;
               break;
            case 15:   // CH78MUTE
            	if (DevParam.CH78MUTE == 1)
               	 DevParam.CH78MUTE = 0;
               break;
            default:
         		break;
         }
         break;
      case 6:   //Right
         FilterChanged = 1;
      	switch (currentFilterMenu)
         {
         	case 0:	// CH12LPF
            	if (DevParam.CH12LPF < 31)
               	 DevParam.CH12LPF += 1;
               break;
            case 1:  // CH12HPF
            	if (DevParam.CH12HPF < 31)
               	 DevParam.CH12HPF += 1;
               break;
            case 2:  // CH12OFFSET
               if (DevParam.CH12OFFSET < 15)
                   DevParam.CH12OFFSET += 1;
               break;
            case 3:   // CH12MUTE
            	if (DevParam.CH12MUTE == 0)
               	 DevParam.CH12MUTE = 1;
               break;
         	case 4:	// CH34LPF
            	if (DevParam.CH34LPF < 31)
               	 DevParam.CH34LPF += 1;
               break;
            case 5:  // CH34HPF
            	if (DevParam.CH34HPF < 31)
               	 DevParam.CH34HPF += 1;
               break;
            case 6:  // CH34OFFSET
               if (DevParam.CH34OFFSET < 15)
                   DevParam.CH34OFFSET += 1;
               break;
            case 7:   // CH34MUTE
            	if (DevParam.CH34MUTE == 0)
               	 DevParam.CH34MUTE = 1;
               break;
         	case 8:	// CH56LPF
            	if (DevParam.CH56LPF < 31)
               	 DevParam.CH56LPF += 1;
               break;
            case 9:  // CH56HPF
            	if (DevParam.CH56HPF < 31)
               	 DevParam.CH56HPF += 1;
               break;
            case 10:  // CH56OFFSET
               if (DevParam.CH56OFFSET < 15)
                   DevParam.CH56OFFSET += 1;
               break;
            case 11:   // CH56MUTE
            	if (DevParam.CH56MUTE == 0)
               	 DevParam.CH56MUTE = 1;
               break;
         	case 12: // CH78LPF
            	if (DevParam.CH78LPF < 31)
               	 DevParam.CH78LPF += 1;
               break;
            case 13:  // CH78HPF
            	if (DevParam.CH78HPF < 31)
               	 DevParam.CH78HPF += 1;
               break;
            case 14:  // CH78OFFSET
               if (DevParam.CH78OFFSET < 15)
                   DevParam.CH78OFFSET += 1;
               break;
            case 15:   // CH78MUTE
            	if (DevParam.CH78MUTE == 0)
               	 DevParam.CH78MUTE = 1;
               break;
            default:
         		break;
         }
         break;
      default:
         //SendString("No Key",2);
         break;
      }

      //Create Screen String
      	switch (currentFilterMenu)
         {
         	case 0:	// CH12LPF
      			sprintf(Line1, "CH1-2 LPF");
               FilterNumToStr(DevParam.CH12LPF,Line2);
               break;
            case 1:  // CH12HPF
      			sprintf(Line1, "CH1-2 HPF");
               FilterNumToStr(DevParam.CH12HPF,Line2);
               break;
            case 2:  // CH12OFFSET
      			sprintf(Line1, "CH1-2 OFFSET");
               sprintf(Line2, "%ddB", DevParam.CH12OFFSET);
               break;
            case 3:   // CH12MUTE
      			sprintf(Line1, "CH1-2 MUTE");
               MuteToStr(DevParam.CH12MUTE, Line2);
               break;
         	case 4:	// CH34LPF
      			sprintf(Line1, "CH3-4 LPF");
               FilterNumToStr(DevParam.CH34LPF,Line2);
               break;
            case 5:  // CH34HPF
      			sprintf(Line1, "CH3-4 HPF");
               FilterNumToStr(DevParam.CH34HPF,Line2);
               break;
            case 6:  // CH34OFFSET
      			sprintf(Line1, "CH3-4 OFFSET");
               sprintf(Line2, "%ddB", DevParam.CH34OFFSET);
               break;
            case 7:   // CH34MUTE
      			sprintf(Line1, "CH3-4 MUTE");
               MuteToStr(DevParam.CH34MUTE, Line2);
               break;
         	case 8:	// CH56LPF
      			sprintf(Line1, "CH5-6 LPF");
               FilterNumToStr(DevParam.CH56LPF,Line2);
               break;
            case 9:  // CH56HPF
      			sprintf(Line1, "CH5-6 HPF");
               FilterNumToStr(DevParam.CH56HPF,Line2);
               break;
            case 10:  // CH56OFFSET
      			sprintf(Line1, "CH5-6 OFFSET");
               sprintf(Line2, "%ddB", DevParam.CH56OFFSET);
               break;
            case 11:   // CH56MUTE
      			sprintf(Line1, "CH5-6 MUTE");
               MuteToStr(DevParam.CH56MUTE, Line2);
               break;
         	case 12: // CH78LPF
      			sprintf(Line1, "CH7-8 LPF");
               FilterNumToStr(DevParam.CH78LPF,Line2);
               break;
            case 13:  // CH78HPF
      			sprintf(Line1, "CH7-8 HPF");
               FilterNumToStr(DevParam.CH78HPF,Line2);
               break;
            case 14:  // CH78OFFSET
      			sprintf(Line1, "CH7-8 OFFSET");
               sprintf(Line2, "%ddB", DevParam.CH78OFFSET);
               break;
            case 15:   // CH78MUTE
      			sprintf(Line1, "CH7-8 MUTE");
               MuteToStr(DevParam.CH78MUTE, Line2);
               break;
            default:
         		break;
         }
      //Send LCD
      if (FilterChanged == 1)
      {
      	strcat(Line1, "  *");
      }
      SendString(Line1,1);
      SendString(Line2,2);
}
void EQTypeToStr(int EQTypeNum, char * RetStr)
{
	switch(EQTypeNum)
   {
	   case 0:
      	strcpy(RetStr, "None");
	      break;
	   case 1:
      	strcpy(RetStr, "LowShelf");
	      break;
	   case 2:
      	strcpy(RetStr, "HighShelp");
	      break;
	   case 3:
      	strcpy(RetStr, "Peaking");
	      break;
	   default:
	      break;
   }
}

void EQFreqNumToStr(int EQFreqNum, char * EQFreqStr)
{
	switch(EQFreqNum)
   {
   	case 0:
      	strcpy(EQFreqStr, "None");
      	break;
   	case 1:
      	strcpy(EQFreqStr, "20Hz");
      	break;
   	case 2:
      	strcpy(EQFreqStr, "25Hz");
      	break;
   	case 3:
      	strcpy(EQFreqStr, "32Hz");
      	break;
   	case 4:
      	strcpy(EQFreqStr, "40Hz");
      	break;
   	case 5:
      	strcpy(EQFreqStr, "50Hz");
      	break;
   	case 6:
      	strcpy(EQFreqStr, "63Hz");
      	break;
   	case 7:
      	strcpy(EQFreqStr, "80Hz");
      	break;
   	case 8:
      	strcpy(EQFreqStr, "100Hz");
      	break;
   	case 9:
      	strcpy(EQFreqStr, "125Hz");
      	break;
   	case 10:
      	strcpy(EQFreqStr, "160Hz");
      	break;
   	case 11:
      	strcpy(EQFreqStr, "200Hz");
      	break;
   	case 12:
      	strcpy(EQFreqStr, "250Hz");
      	break;
   	case 13:
      	strcpy(EQFreqStr, "315Hz");
      	break;
   	case 14:
      	strcpy(EQFreqStr, "400Hz");
      	break;
   	case 15:
      	strcpy(EQFreqStr, "500Hz");
      	break;
   	case 16:
      	strcpy(EQFreqStr, "630Hz");
      	break;
   	case 17:
      	strcpy(EQFreqStr, "800Hz");
      	break;
   	case 18:
      	strcpy(EQFreqStr, "1.0kHz");
      	break;
   	case 19:
      	strcpy(EQFreqStr, "1.25kHz");
      	break;
   	case 20:
      	strcpy(EQFreqStr, "1.6kHz");
      	break;
   	case 21:
      	strcpy(EQFreqStr, "2.0kHz");
      	break;
   	case 22:
      	strcpy(EQFreqStr, "2.5kHz");
      	break;
   	case 23:
      	strcpy(EQFreqStr, "3.15kHz");
      	break;
   	case 24:
      	strcpy(EQFreqStr, "4.0kHz");
      	break;
   	case 25:
      	strcpy(EQFreqStr, "5.0kHz");
      	break;
   	case 26:
      	strcpy(EQFreqStr, "6.3kHz");
      	break;
   	case 27:
      	strcpy(EQFreqStr, "8.0kHz");
      	break;
   	case 28:
      	strcpy(EQFreqStr, "10kHz");
      	break;
   	case 29:
      	strcpy(EQFreqStr, "12.5kHz");
      	break;
   	case 30:
      	strcpy(EQFreqStr, "16kHz");
      	break;
   	case 31:
      	strcpy(EQFreqStr, "20kHz");
      	break;
      default:
      	strcpy(EQFreqStr, "--");
			break;
   }
}

void EQMenu(int NewKeyData)
{
	//Control EQ5,6,7
	char Line1[20];
   char Line2[20];
   float EQQ;

      switch (NewKeyData)
      {
      case 1:  //Enter
      	//save changes
         EQChanged = 0;
         DevParam.currentwin = 4;
         switch (currentfs)
         {
	         case 4:
                applyEQ(44100L);
                break;
	         case 5:
                applyEQ(48000L);
                break;
	         case 6:
                applyEQ(88200L);
                break;
	         case 7:
                applyEQ(96000L);
                break;
         }
        	writeDevParam();
         return;
         break;
      case 2: //Cancel
      	//discard changes
         EQChanged = 0;
      	readDevParam();
         DevParam.currentwin = 2;
        	writeDevParam();
         return;
         break;
      case 3:    //Up
      	if (currentEQMenu > 0)
         	currentEQMenu -= 1;
         break;
         break;
      case 4:    //Down
      	if (currentEQMenu < 47)
         	currentEQMenu += 1;
         break;
      case 5:    //Left
         EQChanged = 1;
      	switch (currentEQMenu)
         {
	         case 0:
	            if ( DevParam.CH12EQ5TYPE > 0 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH12EQ5TYPE -= 1;
	            break;
	         case 1:
	         if ( DevParam.CH12EQ5FREQ > 0 )   //0 - 31
	               DevParam.CH12EQ5FREQ -= 1;
	            break;
	         case 2:
	         if ( DevParam.CH12EQ5Q > 0 )     //0 - 31
	               DevParam.CH12EQ5Q  -= 1;
	            break;
	         case 3:
	         if ( DevParam.CH12EQ5GAIN > -15 )   //-15,... 0,... 15
	               DevParam.CH12EQ5GAIN -= 1;
	            break;
	         case 4:
	         if ( DevParam.CH12EQ6TYPE > 0 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH12EQ6TYPE -= 1;
	            break;
	         case 5:
	         if ( DevParam.CH12EQ6FREQ > 0 )   //0 - 31
	               DevParam.CH12EQ6FREQ -= 1;
	            break;
	         case 6:
	         if ( DevParam.CH12EQ6Q > 0 )     //0 - 31
	               DevParam.CH12EQ6Q  -= 1;
	            break;
	         case 7:
	         if ( DevParam.CH12EQ6GAIN > -15) //-15,... 0,... 15
	               DevParam.CH12EQ6GAIN  -= 1;
	            break;
	         case 8:
	         if ( DevParam.CH12EQ7TYPE > 0 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH12EQ7TYPE  -= 1;
	            break;
	         case 9:
	         if ( DevParam.CH12EQ7FREQ > 0 )   //0 - 31
	               DevParam.CH12EQ7FREQ  -= 1;
	            break;
	         case 10:
	         if ( DevParam.CH12EQ7Q > 0 )     //0 - 31
	               DevParam.CH12EQ7Q  -= 1;
	            break;
	         case 11:
	         if ( DevParam.CH12EQ7GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH12EQ7GAIN  -= 1;
	            break;

	         case 12:
	         if ( DevParam.CH34EQ5TYPE > 0 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH34EQ5TYPE  -= 1;
	            break;
	         case 13:
	         if ( DevParam.CH34EQ5FREQ > 0 )   //0 - 31
	               DevParam.CH34EQ5FREQ  -= 1;
	            break;
	         case 14:
	         if ( DevParam.CH34EQ5Q > 0 )     //0 - 31
	               DevParam.CH34EQ5Q  -= 1;
	            break;
	         case 15:
	         if ( DevParam.CH34EQ5GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH34EQ5GAIN  -= 1;
	            break;
	         case 16:
	         if ( DevParam.CH34EQ6TYPE > 0 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH34EQ6TYPE  -= 1;
	            break;
	         case 17:
	         if ( DevParam.CH34EQ6FREQ > 0 )   //0 - 31
	               DevParam.CH34EQ6FREQ  -= 1;
	            break;
	         case 18:
	         if ( DevParam.CH34EQ6Q > 0 )     //0 - 31
	               DevParam.CH34EQ6Q  -= 1;
	            break;
	         case 19:
	         if ( DevParam.CH34EQ6GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH34EQ6GAIN  -= 1;
	            break;
	         case 20:
	         if ( DevParam.CH34EQ7TYPE > 0 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH34EQ7TYPE  -= 1;
	            break;
	         case 21:
	         if ( DevParam.CH34EQ7FREQ > 0 )   //0 - 31
	               DevParam.CH34EQ7FREQ  -= 1;
	            break;
	         case 22:
	         if ( DevParam.CH34EQ7Q > 0 )     //0 - 31
	               DevParam.CH34EQ7Q  -= 1;
	            break;
	         case 23:
	         if ( DevParam.CH34EQ7GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH34EQ7GAIN  -= 1;
	            break;

	         case 24:
	         if ( DevParam.CH56EQ5TYPE > 0 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH56EQ5TYPE  -= 1;
	            break;
	         case 25:
	         if ( DevParam.CH56EQ5FREQ > 0 )   //0 - 31
	               DevParam.CH56EQ5FREQ  -= 1;
	            break;
	         case 26:
	         if ( DevParam.CH56EQ5Q > 0 )     //0 - 31
	               DevParam.CH56EQ5Q  -= 1;
	            break;
	         case 27:
	         if ( DevParam.CH56EQ5GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH56EQ5GAIN  -= 1;
	            break;
	         case 28:
	         if ( DevParam.CH56EQ6TYPE > 0 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH56EQ6TYPE  -= 1;
	            break;
	         case 29:
	         if ( DevParam.CH56EQ6FREQ > 0 )   //0 - 31
	               DevParam.CH56EQ6FREQ  -= 1;
	            break;
	         case 30:
	         if ( DevParam.CH56EQ6Q > 0 )     //0 - 31
	               DevParam.CH56EQ6Q  -= 1;
	            break;
	         case 31:
	         if ( DevParam.CH56EQ6GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH56EQ6GAIN  -= 1;
	            break;
	         case 32:
	         if ( DevParam.CH56EQ7TYPE > 0 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH56EQ7TYPE  -= 1;
	            break;
	         case 33:
	         if ( DevParam.CH56EQ7FREQ > 0 )   //0 - 31
	               DevParam.CH56EQ7FREQ  -= 1;
	            break;
	         case 34:
	         if ( DevParam.CH56EQ7Q > 0 )     //0 - 31
	               DevParam.CH56EQ7Q  -= 1;
	            break;
	         case 35:
	         if ( DevParam.CH56EQ7GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH56EQ7GAIN  -= 1;
	            break;

	         case 36:
	         if ( DevParam.CH78EQ5TYPE > 0 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH78EQ5TYPE  -= 1;
	            break;
	         case 37:
	         if ( DevParam.CH78EQ5FREQ > 0 )   //0 - 31
	               DevParam.CH78EQ5FREQ  -= 1;
	            break;
	         case 38:
	         if ( DevParam.CH78EQ5Q > 0 )     //0 - 31
	               DevParam.CH78EQ5Q  -= 1;
	            break;
	         case 39:
	         if ( DevParam.CH78EQ5GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH78EQ5GAIN  -= 1;
	            break;
	         case 40:
	         if ( DevParam.CH78EQ6TYPE > 0 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH78EQ6TYPE  -= 1;
	            break;
	         case 41:
	         if ( DevParam.CH78EQ6FREQ > 0 )   //0 - 31
	               DevParam.CH78EQ6FREQ  -= 1;
	            break;
	         case 42:
	         if ( DevParam.CH78EQ6Q > 0 )     //0 - 31
	               DevParam.CH78EQ6Q  -= 1;
	            break;
	         case 43:
	         if ( DevParam.CH78EQ6GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH78EQ6GAIN  -= 1;
	            break;
	         case 44:
	         if ( DevParam.CH78EQ7TYPE > 0 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH78EQ7TYPE  -= 1;
	            break;
	         case 45:
	         if ( DevParam.CH78EQ7FREQ > 0 )   //0 - 31
	               DevParam.CH78EQ7FREQ  -= 1;
	            break;
	         case 46:
	         if ( DevParam.CH78EQ7Q > 0 )    //0 - 31
	               DevParam.CH78EQ7Q  -= 1;
	            break;
	         case 47:
	         if ( DevParam.CH78EQ7GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH78EQ7GAIN  -= 1;
	            break;
	         default:
	            break;
         }
         return;
         break;
      case 6:   //Right
			EQChanged = 1;
         switch (currentEQMenu)
         {
	         case 0:
	            if ( DevParam.CH12EQ5TYPE < 3 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH12EQ5TYPE += 1;
	            break;
	         case 1:
	         if ( DevParam.CH12EQ5FREQ < 31 )   //0 - 31
	               DevParam.CH12EQ5FREQ += 1;
	            break;
	         case 2:
	         if ( DevParam.CH12EQ5Q < 31 )     //0 - 31
	               DevParam.CH12EQ5Q  += 1;
	            break;
	         case 3:
	         if ( DevParam.CH12EQ5GAIN < 15 )   //-15,... 0,... 15
	               DevParam.CH12EQ5GAIN += 1;
	            break;
	         case 4:
	         if ( DevParam.CH12EQ6TYPE < 3 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH12EQ6TYPE += 1;
	            break;
	         case 5:
	         if ( DevParam.CH12EQ6FREQ < 31 )   //0 - 31
	               DevParam.CH12EQ6FREQ += 1;
	            break;
	         case 6:
	         if ( DevParam.CH12EQ6Q < 31 )     //0 - 31
	               DevParam.CH12EQ6Q  += 1;
	            break;
	         case 7:
	         if ( DevParam.CH12EQ6GAIN < 15) //-15,... 0,... 15
	               DevParam.CH12EQ6GAIN  += 1;
	            break;
	         case 8:
	         if ( DevParam.CH12EQ7TYPE < 3 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH12EQ7TYPE  += 1;
	            break;
	         case 9:
	         if ( DevParam.CH12EQ7FREQ < 31 )   //0 - 31
	               DevParam.CH12EQ7FREQ  += 1;
	            break;
	         case 10:
	         if ( DevParam.CH12EQ7Q < 31 )     //0 - 31
	               DevParam.CH12EQ7Q  += 1;
	            break;
	         case 11:
	         if ( DevParam.CH12EQ7GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH12EQ7GAIN  += 1;
	            break;

	         case 12:
	         if ( DevParam.CH34EQ5TYPE < 3 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH34EQ5TYPE  += 1;
	            break;
	         case 13:
	         if ( DevParam.CH34EQ5FREQ < 31 )   //0 - 31
	               DevParam.CH34EQ5FREQ  += 1;
	            break;
	         case 14:
	         if ( DevParam.CH34EQ5Q < 31 )     //0 - 31
	               DevParam.CH34EQ5Q  += 1;
	            break;
	         case 15:
	         if ( DevParam.CH34EQ5GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH34EQ5GAIN  += 1;
	            break;
	         case 16:
	         if ( DevParam.CH34EQ6TYPE < 3 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH34EQ6TYPE  += 1;
	            break;
	         case 17:
	         if ( DevParam.CH34EQ6FREQ < 31 )   //0 - 31
	               DevParam.CH34EQ6FREQ  += 1;
	            break;
	         case 18:
	         if ( DevParam.CH34EQ6Q < 31 )     //0 - 31
	               DevParam.CH34EQ6Q  += 1;
	            break;
	         case 19:
	         if ( DevParam.CH34EQ6GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH34EQ6GAIN  += 1;
	            break;
	         case 20:
	         if ( DevParam.CH34EQ7TYPE < 3 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH34EQ7TYPE  += 1;
	            break;
	         case 21:
	         if ( DevParam.CH34EQ7FREQ < 31 )   //0 - 31
	               DevParam.CH34EQ7FREQ  += 1;
	            break;
	         case 22:
	         if ( DevParam.CH34EQ7Q < 31 )     //0 - 31
	               DevParam.CH34EQ7Q  += 1;
	            break;
	         case 23:
	         if ( DevParam.CH34EQ7GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH34EQ7GAIN  += 1;
	            break;

	         case 24:
	         if ( DevParam.CH56EQ5TYPE < 3 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH56EQ5TYPE  += 1;
	            break;
	         case 25:
	         if ( DevParam.CH56EQ5FREQ < 31 )   //0 - 31
	               DevParam.CH56EQ5FREQ  += 1;
	            break;
	         case 26:
	         if ( DevParam.CH56EQ5Q < 31 )     //0 - 31
	               DevParam.CH56EQ5Q  += 1;
	            break;
	         case 27:
	         if ( DevParam.CH56EQ5GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH56EQ5GAIN  += 1;
	            break;
	         case 28:
	         if ( DevParam.CH56EQ6TYPE < 3 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH56EQ6TYPE  += 1;
	            break;
	         case 29:
	         if ( DevParam.CH56EQ6FREQ < 31 )   //0 - 31
	               DevParam.CH56EQ6FREQ  += 1;
	            break;
	         case 30:
	         if ( DevParam.CH56EQ6Q < 31 )     //0 - 31
	               DevParam.CH56EQ6Q  += 1;
	            break;
	         case 31:
	         if ( DevParam.CH56EQ6GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH56EQ6GAIN  += 1;
	            break;
	         case 32:
	         if ( DevParam.CH56EQ7TYPE < 3 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH56EQ7TYPE  += 1;
	            break;
	         case 33:
	         if ( DevParam.CH56EQ7FREQ < 31 )   //0 - 31
	               DevParam.CH56EQ7FREQ  += 1;
	            break;
	         case 34:
	         if ( DevParam.CH56EQ7Q < 31 )     //0 - 31
	               DevParam.CH56EQ7Q  += 1;
	            break;
	         case 35:
	         if ( DevParam.CH56EQ7GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH56EQ7GAIN  += 1;
	            break;

	         case 36:
	         if ( DevParam.CH78EQ5TYPE < 3 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH78EQ5TYPE  += 1;
	            break;
	         case 37:
	         if ( DevParam.CH78EQ5FREQ < 31 )   //0 - 31
	               DevParam.CH78EQ5FREQ  += 1;
	            break;
	         case 38:
	         if ( DevParam.CH78EQ5Q < 31 )     //0 - 31
	               DevParam.CH78EQ5Q  += 1;
	            break;
	         case 39:
	         if ( DevParam.CH78EQ5GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH78EQ5GAIN  += 1;
	            break;
	         case 40:
	         if ( DevParam.CH78EQ6TYPE < 3 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH78EQ6TYPE  += 1;
	            break;
	         case 41:
	         if ( DevParam.CH78EQ6FREQ < 31 )   //0 - 31
	               DevParam.CH78EQ6FREQ  += 1;
	            break;
	         case 42:
	         if ( DevParam.CH78EQ6Q < 31 )     //0 - 31
	               DevParam.CH78EQ6Q  += 1;
	            break;
	         case 43:
	         if ( DevParam.CH78EQ6GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH78EQ6GAIN  += 1;
	            break;
	         case 44:
	         if ( DevParam.CH78EQ7TYPE < 3 )  //0:None, 1:LowShelf, 2:HighShelf, 3:Peaking
	               DevParam.CH78EQ7TYPE  += 1;
	            break;
	         case 45:
	         if ( DevParam.CH78EQ7FREQ < 31 )   //0 - 31
	               DevParam.CH78EQ7FREQ  += 1;
	            break;
	         case 46:
	         if ( DevParam.CH78EQ7Q < 31 )    //0 - 31
	               DevParam.CH78EQ7Q  += 1;
	            break;
	         case 47:
	         if ( DevParam.CH78EQ7GAIN >  -15)   //-15,... 0,... 15
	               DevParam.CH78EQ7GAIN  += 1;
	            break;
	         default:
	            break;
         }
         break;
      default:
         //SendString("No Key",2);
         break;
      }


      //Create Screen String
      switch (currentEQMenu)
      {
	      case 0: //CH12EQ5TYPE;
	         sprintf(Line1, "CH1-2 EQ5 Type");
            EQTypeToStr(DevParam.CH12EQ5TYPE ,Line2);
	         break;
	      case 1: //CH12EQ5FREQ;
	         sprintf(Line1, "CH1-2 EQ5 Freq");
            EQFreqNumToStr(DevParam.CH12EQ5FREQ, Line2);
	         break;
	      case 2: //CH12EQ5Q;
	         sprintf(Line1, "CH1-2 EQ5 Q");
            EQQ = EQQNumToValue(DevParam.CH12EQ5Q );
            sprintf(Line2, "%f", EQQ);
	         break;
	      case 3: //CH12EQ5GAIN;
	         sprintf(Line1, "CH1-2 EQ5 Gain");
            sprintf(Line2, "%ddB", DevParam.CH12EQ5GAIN);
	         break;
	      case 4: //CH12EQ6TYPE;
	         sprintf(Line1, "CH1-2 EQ6 Type");
            EQTypeToStr(DevParam.CH12EQ6TYPE ,Line2);
	         break;
	      case 5: //CH12EQ6FREQ;
	         sprintf(Line1, "CH1-2 EQ6 Freq");
            EQFreqNumToStr(DevParam.CH12EQ6FREQ, Line2);
	         break;
	      case 6: //CH12EQ6Q;
	         sprintf(Line1, "CH1-2 EQ6 Q");
            EQQ = EQQNumToValue(DevParam.CH12EQ6Q );
            sprintf(Line2, "%f", EQQ);
	         break;
	      case 7: //CH12EQ6GAIN;
	         sprintf(Line1, "CH1-2 EQ6 Gain");
            sprintf(Line2, "%ddB", DevParam.CH12EQ6GAIN);
	         break;
	      case 8: //CH12EQ7TYPE;
	         sprintf(Line1, "CH1-2 EQ7 Type");
            EQTypeToStr(DevParam.CH12EQ7TYPE ,Line2);
	         break;
	      case 9: //CH12EQ7FREQ;
	         sprintf(Line1, "CH1-2 EQ7 Freq");
            EQFreqNumToStr(DevParam.CH12EQ7FREQ, Line2);
	         break;
	      case 10: //CH12EQ7Q;
	         sprintf(Line1, "CH1-2 EQ7 Q");
            EQQ = EQQNumToValue(DevParam.CH12EQ7Q );
            sprintf(Line2, "%f", EQQ);
	         break;
	      case 11: //CH12EQ7GAIN;
	         sprintf(Line1, "CH1-2 EQ7 Gain");
            sprintf(Line2, "%ddB", DevParam.CH12EQ7GAIN);
	         break;
	      case 12: //CH34EQ5TYPE;
	         sprintf(Line1, "CH3-4 EQ5 Type");
            EQTypeToStr(DevParam.CH34EQ5TYPE ,Line2);
	         break;
	      case 13: //CH34EQ5FREQ;
	         sprintf(Line1, "CH3-4 EQ5 Freq");
            EQFreqNumToStr(DevParam.CH34EQ5FREQ, Line2);
	         break;
	      case 14: //CH34EQ5Q;
	         sprintf(Line1, "CH3-4 EQ5 Q");
            EQQ = EQQNumToValue(DevParam.CH34EQ5Q );
            sprintf(Line2, "%f", EQQ);
	         break;
	      case 15: //CH34EQ5GAIN;
	         sprintf(Line1, "CH3-4 EQ5 Gain");
            sprintf(Line2, "%ddB", DevParam.CH34EQ5GAIN);
	         break;
	      case 16: //CH34EQ6TYPE;
	         sprintf(Line1, "CH3-4 EQ6 Type");
            EQTypeToStr(DevParam.CH34EQ6TYPE ,Line2);
	         break;
	      case 17: //CH34EQ6FREQ;
	         sprintf(Line1, "CH3-4 EQ6 Freq");
            EQFreqNumToStr(DevParam.CH34EQ6FREQ, Line2);
	         break;
	      case 18: //CH34EQ6Q;
	         sprintf(Line1, "CH3-4 EQ6 Q");
            EQQ = EQQNumToValue(DevParam.CH34EQ6Q );
            sprintf(Line2, "%f", EQQ);
	         break;
	      case 19: //CH34EQ6GAIN;
	         sprintf(Line1, "CH3-4 EQ6 Gain");
            sprintf(Line2, "%ddB", DevParam.CH34EQ6GAIN);
	         break;
	      case 20: //CH34EQ7TYPE;
	         sprintf(Line1, "CH3-4 EQ7 Type");
            EQTypeToStr(DevParam.CH34EQ7TYPE ,Line2);
	         break;
	      case 21: //CH34EQ7FREQ;
	         sprintf(Line1, "CH3-4 EQ7 Freq");
            EQFreqNumToStr(DevParam.CH34EQ7FREQ, Line2);
	         break;
	      case 22: //CH34EQ7Q;
	         sprintf(Line1, "CH3-4 EQ7 Q");
            EQQ = EQQNumToValue(DevParam.CH34EQ7Q );
            sprintf(Line2, "%f", EQQ);
	         break;
	      case 23: //CH34EQ7GAIN;
	         sprintf(Line1, "CH3-4 EQ7 Gain");
            sprintf(Line2, "%ddB", DevParam.CH34EQ7GAIN);
	         break;
	      case 24: //CH56EQ5TYPE;
	         sprintf(Line1, "CH5-6 EQ5 Type");
            EQTypeToStr(DevParam.CH56EQ5TYPE ,Line2);
	         break;
	      case 25: //CH56EQ5FREQ;
	         sprintf(Line1, "CH5-6 EQ5 Freq");
            EQFreqNumToStr(DevParam.CH56EQ5FREQ, Line2);
	         break;
	      case 26: //CH56EQ5Q;
	         sprintf(Line1, "CH5-6 EQ5 Q");
            EQQ = EQQNumToValue(DevParam.CH56EQ5Q );
            sprintf(Line2, "%f", EQQ);
	         break;
	      case 27: //CH56EQ5GAIN;
	         sprintf(Line1, "CH5-6 EQ5 Gain");
            sprintf(Line2, "%ddB", DevParam.CH56EQ5GAIN);
	         break;
	      case 28: //CH56EQ6TYPE;
	         sprintf(Line1, "CH5-6 EQ6 Type");
            EQTypeToStr(DevParam.CH56EQ6TYPE ,Line2);
	         break;
	      case 29: //CH56EQ6FREQ;
	         sprintf(Line1, "CH5-6 EQ6 Freq");
            EQFreqNumToStr(DevParam.CH56EQ6FREQ, Line2);
	         break;
	      case 30: //CH56EQ6Q;
	         sprintf(Line1, "CH5-6 EQ6 Q");
            EQQ = EQQNumToValue(DevParam.CH56EQ6Q );
            sprintf(Line2, "%f", EQQ);
	         break;
	      case 31: //CH56EQ6GAIN;
	         sprintf(Line1, "CH5-6 EQ6 Gain");
            sprintf(Line2, "%ddB", DevParam.CH56EQ6GAIN);
	         break;
	      case 32: //CH56EQ7TYPE;
	         sprintf(Line1, "CH5-6 EQ7 Type");
            EQTypeToStr(DevParam.CH56EQ7TYPE ,Line2);
	         break;
	      case 33: //CH56EQ7FREQ;
	         sprintf(Line1, "CH5-6 EQ7 Freq");
            EQFreqNumToStr(DevParam.CH56EQ7FREQ, Line2);
	         break;
	      case 34: //CH56EQ7Q;
	         sprintf(Line1, "CH5-6 EQ7 Q");
            EQQ = EQQNumToValue(DevParam.CH56EQ7Q );
            sprintf(Line2, "%f", EQQ);
	         break;
	      case 35: //CH56EQ7GAIN;
	         sprintf(Line1, "CH5-6 EQ7 Gain");
            sprintf(Line2, "%ddB", DevParam.CH56EQ7GAIN);
	         break;
	      case 36: //CH78EQ5TYPE;
	         sprintf(Line1, "CH7-8 EQ5 Type");
            EQTypeToStr(DevParam.CH78EQ5TYPE ,Line2);
	         break;
	      case 37: //CH78EQ5FREQ;
	         sprintf(Line1, "CH7-8 EQ5 Freq");
            EQFreqNumToStr(DevParam.CH78EQ5FREQ, Line2);
	         break;
	      case 38: //CH78EQ5Q;
	         sprintf(Line1, "CH7-8 EQ5 Q");
            EQQ = EQQNumToValue(DevParam.CH78EQ5Q );
            sprintf(Line2, "%f", EQQ);
	         break;
	      case 39: //CH78EQ5GAIN;
	         sprintf(Line1, "CH7-8 EQ5 Gain");
            sprintf(Line2, "%ddB", DevParam.CH78EQ5GAIN);
	         break;
	      case 40: //CH78EQ6TYPE;
	         sprintf(Line1, "CH7-8 EQ6 Type");
            EQTypeToStr(DevParam.CH78EQ6TYPE ,Line2);
	         break;
	      case 41: //CH78EQ6FREQ;
	         sprintf(Line1, "CH7-8 EQ6 Freq");
            EQFreqNumToStr(DevParam.CH78EQ6FREQ, Line2);
	         break;
	      case 42: //CH78EQ6Q;
	         sprintf(Line1, "CH7-8 EQ6 Q");
            EQQ = EQQNumToValue(DevParam.CH78EQ6Q );
            sprintf(Line2, "%f", EQQ);
	         break;
	      case 43: //CH78EQ6GAIN;
	         sprintf(Line1, "CH7-8 EQ6 Gain");
            sprintf(Line2, "%ddB", DevParam.CH78EQ6GAIN);
	         break;
	      case 44: //CH78EQ7TYPE;
	         sprintf(Line1, "CH7-8 EQ7 Type");
            EQTypeToStr(DevParam.CH78EQ7TYPE ,Line2);
	         break;
	      case 45: //CH78EQ7FREQ;
	         sprintf(Line1, "CH7-8 EQ7 Freq");
            EQFreqNumToStr(DevParam.CH78EQ7FREQ, Line2);
	         break;
	      case 46: //CH78EQ7Q;
	         sprintf(Line1, "CH7-8 EQ7 Q");
            EQQ = EQQNumToValue(DevParam.CH78EQ7Q );
            sprintf(Line2, "%f", EQQ);
	         break;
	      case 47: //CH78EQ7GAIN;
	         sprintf(Line1, "CH7-8 EQ7 Gain");
            sprintf(Line2, "%ddB", DevParam.CH78EQ7GAIN);
	         break;
	      default:
	         break;
      }
      //Send LCD
      if (EQChanged == 1)
      {
      	strcat(Line1, " *");
      }
      SendString(Line1,1);
      SendString(Line2,2);
}
void mainScreen(int NewKeyData)
{
	char Line1[20];
   char Line2[20];
   int Volume;
   char Freq[10];

   Volume = (int)(((DevParam.currentvol - 0x48) * -1) / 4);

      switch (NewKeyData)
      {
      case 1:  //Enter
         //SendString("Enter Pressed",2);
         DevParam.currentwin = 1;
        	writeDevParam();
         return;
         break;
      case 2:
         //SendString("Cancel Pressed",2);
         break;
      case 3:    //Up
      	if (Volume < 16)
         {
         	Volume += 1;
				DevParam.currentvol = ((Volume * 4) * -1) + 0x48;
         	writeDevParam();
            I2C_SetVolume();
         }
         break;
      case 4:    //Down
      	if (Volume > -100)
         {
         	Volume -= 1;
	         DevParam.currentvol = ((Volume * 4) * -1) + 0x48;
	         writeDevParam();
            I2C_SetVolume();
         }
         break;
      case 5:    //Left
      	if (DevParam.currentch > 0)
         {
         	DevParam.currentch -= 1;
	         writeDevParam();
            I2C_SetCH();
         }
         break;
      case 6:   //Right
      	if (DevParam.currentch < 7)
         {
         	DevParam.currentch += 1;
	         writeDevParam();
            I2C_SetCH();
         }
         break;
      default:
         //SendString("No Key",2);
         break;
      }

      switch (currentfs)
      {
      	case 4:
         	strcpy(Freq, "44.1kHz");
         	break;
         case 5:
         	strcpy(Freq, "48kHz");
         	break;
         case 6:
         	strcpy(Freq, "88.2kHz");
         	break;
         case 7:
         	strcpy(Freq, "96kHz");
         	break;
         default:
         	strcpy(Freq, "--kHz");
      		break;
      }

      //Create Screen String
      sprintf(Line1, "KDA-TAS4i     D%d", DevParam.currentch);
      sprintf(Line2, "%3ddB Fs=%s", Volume, Freq);
      //Send LCD
      SendString(Line1,1);
      SendString(Line2,2);

}

void ProcessKey(int NewKeyData, int PrevKeyData)
{

	switch (DevParam.currentwin)
   {
   	case 0:
      	mainScreen(NewKeyData);
      	break;
   	case 1:
      	Menu01(NewKeyData);
      	break;
   	case 2:
      	Menu02(NewKeyData);
      	break;
   	case 3:
      	FilterMenu(NewKeyData);
      	break;
   	case 4:
      	EQMenu(NewKeyData);
      	break;
      default:
         break;
   }

//   if (PrevKeyData == NewKeyData) && (NewKeyData != 0)
//   {
//         SendString("Same Key",2);
//   }
}


void initializeBoard()
{
 	jrioInit();
	i2c_init();
   currentfs = 0;

	readDevParam();

	serBopen(19200);
   ClearLCD();
   SendString("KOON DIGITAL DIY",1);
   SendString("Starting Up..",2);
  	msDelay(1500);
   ClearLCD();
}

void main()
{
	int return_code;
   unsigned char WriteData;
   int i;
   static int newfs;
   static unsigned char MUTEMode;
   int NewKeyData;
   int PrevKeyData;

   NewKeyData = 0;
   PrevKeyData = 0;

   MUTEMode = 0xFF;
  	msDelay(100);
   initializeBoard();

   //Serial Audio Format = 1 0 00 0 1 0 1   (I2S 24bit)
   WriteData = 0x85;   //I2S
   I2CWrite(CS8416_ADDRESS, 0x05, &WriteData, 1);

   //Control3 = 10110000
   WriteData = 0xB0;   //1011 GPIO is TX passthrough
   I2CWrite(CS8416_ADDRESS, 0x03, &WriteData, 1);

	I2C_SetCH();

   //Clear Err
   WriteData = 0x00;
   return_code = I2CWrite(TAS5508_ADDRESS, 0x02, &WriteData, 1);

	//set volume
   I2C_SetVolume();

   //set mute pattern
   WriteData = 0x00;       //Unmute all
   //WriteData = 0xC0;       //1-6
   return_code = I2CWrite(TAS5508_ADDRESS, 0x0F, &WriteData, 1);

   while (1)
   {
	  BigLoopTop();			// begin a big endless loop

     costate
     {
	      //task for check fs
	      newfs = I2C_GetFs();
	      if (currentfs != newfs)
	      {
	         if ((newfs != 4) && (newfs != 5) && (newfs != 6) && (newfs != 7)) //non support
	         {
                //mute all
                MUTEMode = 0xFF;
			       I2CWrite(TAS5508_ADDRESS, 0x0f, &MUTEMode, 1);
	         }
	         if (newfs == 4) //44.1kHz
	         {
                //Filter 44100
                applyfilter(44100L);
                applyEQ(44100L);
	         }
	         if (newfs == 5) //48kHz
	         {
                //Filter 48000
                applyfilter(48000L);
                applyEQ(48000L);
	         }
	         if (newfs == 6) //88.2kHz
	         {
                //Filter 88200
                applyfilter(88200L);
                applyEQ(88200L);
	         }
	         if (newfs == 7) //96kHz
	         {
                //Filter 96000
                applyfilter(96000L);
                applyEQ(96000L);
	         }
	      	currentfs = newfs;
         }
         waitfor(DelayMs(469));		// wait
     }
     costate      //Task Key Process
     {
         NewKeyData = PollKey();
        	ProcessKey(NewKeyData, PrevKeyData);
         PrevKeyData = NewKeyData;
         waitfor(DelayMs(127));		// wait 50 ms
     }
    }
   serBclose();

}



